--[[============================================================================
main.lua
============================================================================]]--

-- Placeholder for the dialog
local dialog = nil

-- Placeholder to expose the ViewBuilder outside the show_dialog() function
local vb = nil

-- Reload the script whenever this file is saved. 
-- Additionally, execute the attached function.
_AUTO_RELOAD_DEBUG = function()
  
end

local function get_track_device_data()
    --[[
    A common helper for next/prev trackdevice preset functions
    --]]
    local this_device = renoise.song().selected_device
    if this_device == nil then
        --no device selected
        return false
    end
    local p_nr = #this_device.presets
    renoise.app():show_status("nr of presets for this device:"..p_nr)
    if p_nr == 0 then
        --no presets for this device
        return false
    end
    if p_nr == 1 then
        --test for a special case
        local p_name = this_device:preset(1)
        if p_name == 'empty' then
            return false
        end
    end
    local p_current = this_device.active_preset
    if p_current == 0 then
        --modified preset
        renoise.app():show_status("No preset selected!")
        return false
    end
    return true, this_device, p_nr, p_current
end

local function select_next()
    --[[
    Selects next TRACK DEVICE VST preset
    --]]
    
    local success, this_device, p_nr, p_current = get_track_device_data()
    if success == false then
        --Failed for some reason
        return false
    end
    --Roll fwd
    p_current = p_current + 1
    if p_current > p_nr then
        p_current = 1
    end
    this_device.active_preset = p_current

    return true
end

local function select_prev()
    --[[
    Selects previous TRACK DEVICE VST preset
    --]]
    
    local success, this_device, p_nr, p_current = get_track_device_data()
    if success == false then
        --Failed for some reason
        return false
    end
    --Roll fwd
    p_current = p_current - 1
    if p_current == 0 then
        p_current = p_nr
    end
    this_device.active_preset = p_current

    return true
end

--------------------------------------------------------------------------------
-- Key Binding
--------------------------------------------------------------------------------

renoise.tool():add_keybinding {
  name = "Global:Tools:Next VST preset",
  invoke = select_next
}

renoise.tool():add_keybinding {
  name = "Global:Tools:Prev. VST preset",
  invoke = select_prev
}

--------------------------------------------------------------------------------
-- MIDI Mapping
--------------------------------------------------------------------------------

--[[
renoise.tool():add_midi_mapping {
  name = tool_id..":Show Dialog...",
  invoke = show_dialog
}
--]]
